//
//  QRScannerController.swift
//  FinApp
//
//  Created by Александр on 10/03/2019.
//  Copyright © 2019 Alex. All rights reserved.
//

import UIKit
import AVFoundation

class QRScannerController: UIViewController, AVCaptureMetadataOutputObjectsDelegate {

    @IBOutlet weak var frame: UIImageView!
    
    //zobrazuje video uživateli, když chce použít fotoaparát pro qr code
    var video:AVCaptureVideoPreviewLayer!
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        //vytvoření relace
        let session = AVCaptureSession()
        //identifikovat zachycovací zařízení
        guard let captureDevice =  AVCaptureDevice.default(for: .video) else { return }
        let input: AVCaptureDeviceInput
        
        do
        {
            input = try AVCaptureDeviceInput(device: captureDevice)
            session.addInput(input)
        }
        catch
        {
           print("ERROR")
        }
        let output = AVCaptureMetadataOutput()
        session.addOutput(output)
        output.setMetadataObjectsDelegate(self, queue: DispatchQueue.main)
        output.metadataObjectTypes = [.qr]
    
        video = AVCaptureVideoPreviewLayer(session: session)
        video!.frame = view.layer.bounds
        view.layer.addSublayer(video)
        self.view.bringSubviewToFront(frame)
        session.startRunning()
        }
    func metadataOutput(_ output: AVCaptureMetadataOutput, didOutput metadataObjects: [AVMetadataObject], from connection: AVCaptureConnection) {
        if metadataObjects.count != 0{
            if let object = metadataObjects[0] as? AVMetadataMachineReadableCodeObject{
                if object.type == .qr{
                    let alert = UIAlertController(title: "QR Code", message: object.stringValue, preferredStyle: .alert)
                    alert.addAction(UIAlertAction(title: "Retake", style: .default, handler: nil))
                    alert.addAction(UIAlertAction(title: "Copy", style: .default, handler: { (nil) in
                        UIPasteboard.general.string = object.stringValue
                }))
             present(alert, animated: true, completion: nil)
            }
        }
    }

  }
}
